<?php
/**
* init.error.php
* ------------------------------------------------------------
* Package:   MyGosuClan
* Version:   1.03
* License:   GNU GPL
* Author:    cagrET (Cezary Tomczak)
* Email:     cagret@yahoo.com
* Homepage:  http://cagret.prv.pl
* ------------------------------------------------------------
*/

// we do display errors ( its insecure, but newbies need that ;-] )
@ini_set('display_errors', 1);

// we build our own error_reporting, so default error_reporting() is useless
// if u want to change error reporting use this var
global $error_reporting;
//this has been already set in initialize.php
//$error_reporting = E_ALL;

// pseudo var for catching errors ...
global $error_stack;
$errors_stack = 0;

global $my_error;
$my_error =& new my_error;

//our own error handling ( i like clean code ! ;-] )
set_error_handler('my_error_handler');

//our own error hadling function
function my_error_handler($errno, $errmsg, $file, $line)
{
    global $error_reporting;

    if (! ($errno & error_reporting()) ) {
        return;
    }
    if (! ($errno & $error_reporting) ) {
        return;
    }

    $errortype = array
    (
        1    => "PHP Error",
        2    => "PHP Warning",
        4    => "Parsing Error",
        8    => "PHP Notice",
        16   => "Core Error",
        32   => "Core Warning",
        64   => "Compile Error",
        128  => "Compile Warning",
        256  => "User Error",
        512  => "User Warning",
        1024 => "User Notice"
    );

    $errors_limit = 5;

    global $errors_stack;
    ++$errors_stack;

    $file_base = basename($file);
    $file_dir  = dirname($file);

    $output  = "<pre>\n";
    $output .= "<b>{$errortype[$errno]}</b>: $errmsg \n";
    $output .= "<b>File</b>: $file_base ($file_dir)\n";
    $output .= "<b>Line</b>: $line\n";
    $output .= "</pre>\n";

    echo $output;

    if ($errno == 256) {
        exit("<pre>Script execution halted.</pre>\n");
    }

    static $count;
    isset($count) ? ++$count : $count = 1;

    // aftert 5 errors we halt script
    if ($count >= $errors_limit) {
        exit("<pre>Limit of {$errors_limit} errors !</pre>");
    }
}

// our class to catch errors

class my_error
{
    var $stack = null;
    
    function catch()
    {
        global $errors_stack;
        
        $this->stack = $errors_stack;
    }
    
    function isError()
    {
        global $errors_stack;
        
        return ($this->stack <> $errors_stack) ? true : false;
    }
}

?>
